Package com.emc.d2fs.interfaces

# Interface ILocateService

public interface ILocateService
Document location service.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `List<String>`
  `locate(Context context, String id)`
  Deprecated.
  (see `locateById(Context, String)`
  `List<String>`
  `locateByDql(Context context, String dql)`
  Return full path of parent ids to locate document
  `List<String>`
  `locateById(Context context, String id)`
  Return full path of parent ids to locate document
  `List<String>`
  `locateById(Context context, String id, boolean includePartialPaths, boolean doChangePref)`
  Return full path of parent ids to locate document
  `List<String>`
  `locateByName(Context context, String objectName)`
  Return full path of parent ids to locate document
  `List<String>`
  `locateByPath(Context context, String path, List<Attribute> attributes)`
  Return full path of parent ids to locate document
  `List<String>`
  `locateByType(Context context, String type, String value, List<Attribute> attributes)`
  Return full path of parent ids to locate document
  `String`
  `locateForBreadCrumb(Context context, String id, List<Attribute> attributes)`
  Return full path of parent ids to locate document with all BreadCrumb Information The String must be split in 3, using |, the first part is the locate path using / the second part is the Label info splitted using ¬ matching the number of path elements the third part is the icon info splitted using ¬ matching the number of path elements

- ## Method Details

  - ### locate

    List<String> locate(Context context, String id) throws Exception
    Deprecated.
    (see `locateById(Context, String)`
    Return full path of parent ids to locate document
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of document id
    Returns:
      String list of ids corresponding to the path
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### locateById

    List<String> locateById(Context context, String id) throws Exception
    Return full path of parent ids to locate document
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of document id
    Returns:
      String list of ids corresponding to the path
    Throws:
      `Exception`
    Since:
      4.2

  - ### locateById

    List<String> locateById(Context context, String id, boolean includePartialPaths, boolean doChangePref) throws Exception
    Return full path of parent ids to locate document
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of document id
      `boolean` - include partial paths
      `boolean` - do change preferences
    Returns:
      String list of ids corresponding to the path
    Throws:
      `Exception`
    Since:
      4.2

  - ### locateForBreadCrumb

    String locateForBreadCrumb(Context context, String id, List<Attribute> attributes) throws Exception
    Return full path of parent ids to locate document with all BreadCrumb Information The String must be split in 3, using |, the first part is the locate path using / the second part is the Label info splitted using ¬ matching the number of path elements the third part is the icon info splitted using ¬ matching the number of path elements
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of document id (use of id determined by 'locationType')
      `attributes` - `Attribute` list of attributes
      It may contain the following attribute name :
      - locationType : String value of location type (id, name, dql, path, version)
    Returns:
      String joined of ids|labels|icons corresponding to all information needed for breadCrumb
    Throws:
      `Exception`
    Since:
      4.2.0

  - ### locateByName

    List<String> locateByName(Context context, String objectName) throws Exception
    Return full path of parent ids to locate document
    Parameters:
      `context` - `Context` object containing informations about client/session
      `objectName` - String value of document object name
    Returns:
      String list of ids corresponding to the path
    Throws:
      `Exception`
    Since:
      4.2

  - ### locateByDql

    List<String> locateByDql(Context context, String dql) throws Exception
    Return full path of parent ids to locate document
    Parameters:
      `context` - `Context` object containing informations about client/session
      `dql` - String value of dql request
    Returns:
      String list of ids corresponding to the path
    Throws:
      `Exception`
    Since:
      4.2

  - ### locateByPath

    List<String> locateByPath(Context context, String path, List<Attribute> attributes) throws Exception
    Return full path of parent ids to locate document
    Parameters:
      `context` - `Context` object containing informations about client/session
      `path` - String value of path requested, can be composed of either object_name or id, as long as each path element is separated by a slash /
      `attributes` - attributes `Attribute` list of parameters
      It may contain the following attribute name :
      - locateId : String containing locate id
      - locateName : String containing locate name
    Returns:
      String list of ids corresponding to the path
    Throws:
      `Exception`
    Since:
      4.2

  - ### locateByType

    List<String> locateByType(Context context, String type, String value, List<Attribute> attributes) throws Exception
    Return full path of parent ids to locate document
    Parameters:
      `context` - `Context` object containing informations about client/session
      `type` - String locate type
      `value` - String location parameter value (depending of the locate type, either id, name, dql or path)
      `attributes` - attributes `Attribute` list of parameters
    Returns:
      String list of ids corresponding to the path
    Throws:
      `Exception`
    Since:
      4.2